import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare_example/routes/app_router.dart';
import 'package:contentsquare_example/src/widgets/contentsquare_screen_monitor.dart';
import 'package:flutter/material.dart';
import 'package:flutter_driver/driver_extension.dart';

void main() async {
  enableFlutterDriverExtension();

  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  void initState() {
    ContentsquareScreenMonitor.sendScreenView(
      context,
      screenName: 'HomeRoute',
    );
    super.initState();
  }

  final _appRouter = AppRouter();

  @override
  Widget build(BuildContext context) {
    return ContentsquareRoot(
      child: MaterialApp.router(
        routerDelegate: _appRouter.delegate(
          navigatorObservers: () => [getRouteObserver()],
        ),
        routeInformationParser: _appRouter.defaultRouteParser(),
        theme: ThemeData(
          textTheme: TextTheme(
            titleSmall: TextStyle(
              fontStyle: FontStyle.italic,
              fontWeight: FontWeight.normal,
              fontSize: 15,
            ),
          ),
          outlinedButtonTheme: OutlinedButtonThemeData(
            style: OutlinedButton.styleFrom(
              side: BorderSide(color: Colors.black, width: 0.5),
              shape: RoundedRectangleBorder(
                borderRadius: BorderRadius.circular(4),
              ),
            ),
          ),
        ),
      ),
    );
  }
}
