import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare_example/src/widgets/app_bar.dart';
import 'package:flutter/material.dart';
import 'package:flutter_inappwebview/flutter_inappwebview.dart';

class TrackedInAppWebViewScreen extends StatelessWidget {
  const TrackedInAppWebViewScreen({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: appBar(title: 'Tracked (flutter_inappwebview)'),
      body: ContentsquareWebViewTrackerBuilder(
        builder: (context, tracker) {
          return InAppWebView(
            initialUrlRequest: URLRequest(
              url: Uri.parse(
                'https://tupeuxpastest.csq.io/mobile/web-view-cart.html',
              ),
            ),
            onWebViewCreated: (controller) {
              tracker.registerWebViewController(
                ContentsquareWebViewController(
                  evaluateJavascript: (source) async {
                    return '${await controller.evaluateJavascript(source: source)}';
                  },
                  currentUrl: () async => '${await controller.getUrl()}',
                  javascriptChannelCall: (channelName, data) {
                    return 'window.flutter_inappwebview.callHandler("$channelName", $data)';
                  },
                ),
              );

              for (final javascriptChannel in tracker.javascriptChannels) {
                controller.addJavaScriptHandler(
                  handlerName: javascriptChannel.name,
                  callback: (args) {
                    javascriptChannel.onMessageReceived(args.first);
                  },
                );
              }
            },
            onLoadStop: (_, __) => tracker.startPageTracking(),
          );
        },
      ),
    );
  }
}
