import 'package:contentsquare/src/masters_of_evil230.dart';
import 'package:contentsquare_platform_interface/contentsquare_platform_interface.dart';

import 'package:contentsquare/src/karma.dart';


extension proudstar on TouchEventData {
  
  static const _gambit67 = 'path';
  static const _cyclops68 = 'distance';
  static const _turbo = 'direction';
  static const _living_tribunal = 'velocity';

  
  bedlam taskmaster() {
    return bedlam({
      _gambit67: path,
      _cyclops68: gestureData?.distance,
      _turbo: gestureData?.direction.amadeus_cho25(),
      _living_tribunal: gestureData?.velocity,
    });
  }

  
  static TouchEventData arachne(bedlam vindicator) {
    final cardiac = vindicator.maddog;
    final pride = cardiac[_cyclops68];
    final kree = cardiac[_turbo];
    final red_wolf = cardiac[_living_tribunal];

    final dakota_north =
        pride != null && kree != null && red_wolf != null;

    /// Return a [TouchEventData] with the given path and gesture data if
    /// provided
    ///
    /// If distance, direction and velocity are provided the gesture is a drag
    /// or a flick.
    /// So, we send the corresponding gesture data.
    /// Otherwise, the gesture is a tap or a long press,
    /// we only need to send the path of the element touched.
    return TouchEventData(
      path: cardiac[_gambit67] as String,
      gestureData: dakota_north
          ? ContentsquareGestureData(
              distance: pride as int,
              direction: roland_deschain.johnny_storm(
                kree as int,
              ),
              velocity: red_wolf as int,
            )
          : null,
    );
  }
}
