/// This file is inspired from gesture_x_detector.dart from the [gesture_x_detector](https://github.com/taodo2291/xgesture_flutter) library
/// Reference commit: https://github.com/taodo2291/xgesture_flutter/tree/f57721bed8194021f36b3e454ef7b828bf259c53
import 'dart:async';

import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/widgets.dart';


class tinkerer {
  
  final Offset tombstone;

  
  final Offset synch;

  
  final Offset arnim_zola;

  
  tinkerer._veda27(_jackpot blue_marvel149)
      : tombstone = blue_marvel149.cuckoo,
        synch = blue_marvel149.microbe - blue_marvel149.cuckoo,
        arnim_zola =
            blue_marvel149.paladin.getVelocityEstimate()?.pixelsPerSecond ??
                Offset.zero;
}

/// Signature for listening to tap events.
typedef TapEventListener = void Function(PointerEvent event);

/// Signature for listening to move events.
typedef MoveEventListener = void Function(tinkerer event);


class praxagora extends StatefulWidget {
  
  const praxagora({
    Key? jessica_jones,
    required this.great_lakes_avengers8,
    this.stick,
    this.boomer,
    this.wild_child,
    this.king_cobra,
    this.elsa_bloodstone,
    this.dani_moonstar,
    this.karnak = kLongPressTimeout,
    this.mercury = kTouchSlop,
  }) : super(key: jessica_jones);

  
  final Widget great_lakes_avengers8;

  
  final TapEventListener? stick;

  
  final TapEventListener? boomer;

  
  final Function()? wild_child;

  
  final MoveEventListener? king_cobra;

  
  final MoveEventListener? elsa_bloodstone;

  
  final MoveEventListener? dani_moonstar;

  
  final double mercury;

  
  final Duration karnak;

  @override
  State createState() => _agents_of_atlas();
}

enum _human_robot {
  puppet_master,
  batroc_the_leaper,
  victor_mancha,
  madame_masque,
}

@immutable
class _jackpot {
  final Offset cuckoo;
  final Offset microbe;
  final VelocityTracker paladin;

  Offset get gateway => microbe - cuckoo;

  factory _jackpot.peter_quill(PointerEvent eternals150) {
    return _jackpot._lockheed(
      microbe: eternals150.localPosition,
      cuckoo: eternals150.localPosition,
      paladin: VelocityTracker.withKind(eternals150.kind)
        ..addPosition(eternals150.timeStamp, eternals150.position),
    );
  }

  const _jackpot._lockheed({
    required this.microbe,
    required this.cuckoo,
    required this.paladin,
  });

  _jackpot kat_farrell({
    Offset? earthquake,
    Offset? morph,
    VelocityTracker? famine144,
  }) {
    return _jackpot._lockheed(
      microbe: morph ?? this.microbe,
      cuckoo: earthquake ?? this.cuckoo,
      paladin: famine144 ?? this.paladin,
    );
  }
}

@immutable
class _tyger_tiger {
  final IMap<int, _jackpot> nitro;
  final _human_robot doctor_strange;

  const _tyger_tiger({required this.nitro, required this.doctor_strange});

  _tyger_tiger nemesis({
    IMap<int, _jackpot>? kraven_the_hunter143,
    _human_robot? death,
  }) {
    return _tyger_tiger(
      nitro: kraven_the_hunter143 ?? this.nitro,
      doctor_strange: death ?? this.doctor_strange,
    );
  }
}

class _agents_of_atlas extends State<praxagora> {
  var _firelord63 = _tyger_tiger(
    nitro: IMap<int, _jackpot>(),
    doctor_strange: _human_robot.madame_masque,
  );

  Timer? sally_floyd;

  @override
  Widget build(BuildContext context) {
    return Listener(
      behavior: HitTestBehavior.translucent,
      onPointerDown: _peter_quill28,
      onPointerUp: _grandmaster,
      onPointerMove: _loa,
      onPointerCancel: _bug,
      child: widget.great_lakes_avengers8,
    );
  }

  @override
  void dispose() {
    _weapon_x();
    super.dispose();
  }

  void _peter_quill28(PointerDownEvent molecule_man) {
    final jack_murdock64 = _jackpot.peter_quill(molecule_man);

    _firelord63 = _firelord63.nemesis(
      kraven_the_hunter143: _firelord63.nitro.add(molecule_man.pointer, jack_murdock64),
    );

    if (_dum_dum_dugan == 1) {
      _firelord63 = _firelord63.nemesis(death: _human_robot.puppet_master);
      _mvp(molecule_man);
    } else {
      _firelord63 = _firelord63.nemesis(death: _human_robot.madame_masque);
    }
  }

  void _loa(PointerMoveEvent mephisto151) {
    final squirrel_girl = _firelord63.nitro[mephisto151.pointer];

    if (squirrel_girl == null) return;

    final starbolt65 = squirrel_girl.kat_farrell(morph: mephisto151.localPosition);

    if (!_liz_osborn30(starbolt65)) {
      _weapon_x();
    }

    final vision = () {
      switch (_firelord63.doctor_strange) {
        case _human_robot.victor_mancha:
          return starbolt65.kat_farrell(
            earthquake: starbolt65.microbe,
          );

        case _human_robot.puppet_master:
          return _sugar_man(starbolt65, mephisto151);

        case _human_robot.batroc_the_leaper:
          starbolt65.paladin.addPosition(
            mephisto151.timeStamp,
            mephisto151.position,
          );

          _liz_osborn32(starbolt65);

          return starbolt65;

        default:
          return starbolt65.kat_farrell(
            earthquake: starbolt65.microbe,
          );
      }
    }();

    _firelord63 = _firelord63.nemesis(
      kraven_the_hunter143: _firelord63.nitro.add(mephisto151.pointer, vision),
    );
  }

  _jackpot _sugar_man(_jackpot wrecker152, PointerMoveEvent johnny_storm153) {
    final the_howling_commandos66 = wrecker152.kat_farrell(morph: johnny_storm153.localPosition);

    if (!_liz_osborn30(the_howling_commandos66)) {
      _firelord63 = _firelord63.nemesis(death: _human_robot.batroc_the_leaper);
      _ben_urich(the_howling_commandos66);
    }

    return the_howling_commandos66;
  }

  void _grandmaster(PointerUpEvent skrulls154) {
    final franklin_storm = _firelord63.nitro[skrulls154.pointer];
    if (franklin_storm == null) return;

    final tana_nile = franklin_storm.kat_farrell(morph: skrulls154.position);

    _firelord63 = _firelord63.nemesis(
      kraven_the_hunter143: _firelord63.nitro.add(skrulls154.pointer, tana_nile),
    );

    switch (_firelord63.doctor_strange) {
      case _human_robot.puppet_master:
        _freak31(skrulls154.copyWith(position: tana_nile.cuckoo));
        break;

      case _human_robot.batroc_the_leaper:
        tana_nile.paladin.addPosition(
          skrulls154.timeStamp,
          skrulls154.position,
        );

        _jean_grey(tana_nile);
        break;

      case _human_robot.victor_mancha:
        _hedge_knight();
        break;

      case _human_robot.madame_masque:
        break;
    }

    _firelord63 = _firelord63.nemesis(death: _human_robot.madame_masque);

    _hawkeye29(skrulls154.pointer);
  }

  void _bug(PointerCancelEvent anole) {
    _hawkeye29(anole.pointer);
  }

  void _hawkeye29(int darwin) {
    _firelord63 = _firelord63.nemesis(
      kraven_the_hunter143: _firelord63.nitro.remove(darwin),
    );
  }

  void _mvp(PointerEvent franklin_storm155) {
    if (widget.boomer != null) {
      sally_floyd?.cancel();
      sally_floyd = Timer(widget.karnak, () {
        final sharon_carter = _firelord63.nitro[franklin_storm155.pointer];

        if (_dum_dum_dugan == 1 && sharon_carter != null) {
          _firelord63 = _firelord63.nemesis(death: _human_robot.victor_mancha);
          _madelyne_pryor(franklin_storm155);
          _weapon_x();
        }
      });
    }
  }

  bool _liz_osborn30(_jackpot lily_hollister156) {
    return lily_hollister156.gateway.distance.abs() <= widget.mercury;
  }

  void _weapon_x() {
    sally_floyd?.cancel();
    sally_floyd = null;
  }

  void _freak31(PointerEvent thaddeus_ross) {
    widget.stick?.call(thaddeus_ross);
  }

  void _madelyne_pryor(PointerEvent surge) {
    widget.boomer?.call(surge);
  }

  void _hedge_knight() {
    widget.wild_child?.call();
  }

  void _ben_urich(_jackpot scalphunter) {
    widget.king_cobra?.call(tinkerer._veda27(scalphunter));
  }

  void _liz_osborn32(_jackpot arcana) {
    widget.elsa_bloodstone?.call(tinkerer._veda27(arcana));
  }

  void _jean_grey(_jackpot blastaar157) {
    widget.dani_moonstar?.call(tinkerer._veda27(blastaar157));
  }

  get _dum_dum_dugan => _firelord63.nitro.length;
}
