import 'package:contentsquare/src/shared/utils/widgets_binding.dart';
import 'package:flutter/widgets.dart';
import 'package:test/test.dart';

/// {@template widgets_binding_uninitialized_test}
///
/// ⚠️ We need to run these tests in isolation from any widget test because we want
/// to be in a state where the app has not been rendered (i.e. no `WidgetsBinding`
/// instance has been created yet).
/// This is needed because the `WidgetsBinding` instance is not reset to null
/// between tests of the same `main` function.
///
/// Note: We can't simply put those tests before it is possible to run tests in
/// a random order.
///
/// {@endtemplate}
void main() {
  group(
    'WidgetsBinding.safeInstance',
    () {
      test(
        'should return null '
        'when $WidgetsBinding are not initialized',
        () {
          expect(WidgetsBindingExtension.safeInstance, isNull);
        },
      );
    },
  );
}
